<?php
/**
* @version $Id: heimdal.php 004 2005-12-15 05:54:21Z impleri $
* @package Heimdal
* @copyright Copyright (C) 2005 impleri.net. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Heimdal is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

/*
  * Main function that replaces some user table and session table
  * fields to make Joomla compatible with phpBB
  */ 
function h_adjust ( $sql, $type ) 
{
	global $database;
	if(defined("IN_INSTALL"))
	{
		return $sql;
	}
	// Predefine variables
	$match = array();
	$_update = $_insert = false;
	$_from = 0;
	
	// Check to see what kind of query we have
	// Sets $_from
	if (strtolower(substr($sql,0,3)) == 'sel') 
	{
		preg_match('/from/i', $sql, $match, PREG_OFFSET_CAPTURE);
	} 
	elseif(strtolower(substr($sql,0,3)) == 'upd') 
	{
		$_update = true;
		if(!preg_match('/set/i', $sql, $match, PREG_OFFSET_CAPTURE) && preg_match('/values/i', $sql))
		{
			$_from = 1;
		}
	} 
	elseif(strtolower(substr($sql,0,3)) == 'ins') 
	{
		$_insert = true;
		if(!preg_match('/set/i', $sql, $match, PREG_OFFSET_CAPTURE) && preg_match('/values/i', $sql))
		{
			$_from = 1;
		}
	}
	$_from = (!empty($match)) ? intval($match[0][1]) : $_from;

	// Define more variables
	$startPos = $k = 0;
	$n = strlen($sql);
	$_alias = $_alias2 = $literal = '';
	$table = $database->_table_prefix;
	switch ($type)
	{
		case 'u':
			$table .= 'users';
			$_find = array('id', 'password', 'email', 'activation', 'block', '\*');
			$_add = array(
				'\*' => '',
				'id' => ' AS `id`',
				'password' => ' AS `password`',
				'email' => ' AS `email`',
				'activation' => ' AS `activation`',
				'block' => ' AS `block`',
			);
			$_replace = array(
				'\*' => array(
					'`user_id` as `id`',
					'`user_password` as `password`',
					'`user_active` as `block`',
					'`user_email` as `email`',
					'`user_actkey` as `activation`',
					'`username`',
					'`name`',
					'`usertype`',
					'`gid`',
					'`registerDate`',
					'`lastvisitDate`',
					'`sendEmail`',
					'`params` ',
					),
				'id' => '`user_id`',
				'password' => '`user_password`',
				'email' => '`user_email`',
				'activation' => '`user_actkey`',
				'block' => '`user_active`',
			);
			break;
		case 's':
			$table .= 'session';
			$_find = array('userid', 'time', 'guest', '\*');
			$_add = array(
				'\*' => '',
				'userid' => ' AS `userid`',
				'time' => ' AS `time`',
				'guest' => ' AS `guest`',
			);
			$_replace = array(
				'\*' => array(
					'`session_user_id` as `userid`',
					'`session_time` as `time`',
					'`session_logged_in` as `guest`',
					'`session_id`',
					'`username`',
					'`usertype`',
					'`gid`',
					'`session_start`',
					'`session_time`',
					'`session_ip`',
					'`session_page`',
					'`session_admin` ',
					),
				'userid' => '`session_user_id`',
				'time' => '`session_time`',
				'guest' => '`session_logged_in`',
			);
			break;
	}
	$_len = strlen($table);
	
	// Search query for table alias referencing our current table
	while($it = strpos($sql, $table, $j))
	{
		$j = $it + $_len;
		if($j > $n)
		{
			break;
		}
		
		if ( $sql{$j} == ' ') 
		{
			$j++;
		}
		if ( $sql{$j} == ' ') 
		{
			$j++;
		}
		if ( strtolower(substr($sql,$j,2)) == 'as' )
		{
			$j = $j + 2;
		}
		if ( $sql{$j} == ' ') 
		{
			$j++;
		}
		if ( $sql{$j} == ' ') 
		{
			$j++;
		}
		if (!( $sql{$j} == ',' || strtolower(substr($sql,$j,2)) == 'wh' || $sql{$j} == '(' || $sql{$j} == ')' || $sql{$j} == "\n" || strtolower(substr($sql,$j,2)) == 'se' ))
		{
			$sub = (strpos($sql, " ", $j) > 0) ? strpos($sql, " ", $j) : $n;
			$sub = (($sub > strpos($sql, ",", $j)) && strpos($sql, ",", $j) > 0) ? strpos($sql, ",", $j) : $sub;
			$sub = (($sub > strpos($sql, "\n", $j)) && strpos($sql, "\n", $j) > 0) ? strpos($sql, "\n", $j) : $sub;
			if(empty($_alias)) 
			{
				$_alias = trim(substr($sql, $j, $sub-$j));
				$_alias = (strpos($_alias, ',')) ? substr($_alias, 0, strpos($_alias, ',')-1) : $_alias;
				$_alias = (strlen($_alias) > 3) ? substr($_alias, 0, 1) : $_alias;
				$_alias = (empty($_alias)) ? '' : $_alias . '.';
			} 
			else 
			{
				$_alias2 = trim(substr($sql, $j, $sub-$j));
				$_alias2 = (strpos($_alias2, ',')) ? substr($_alias2, 0, strpos($_alias2, ',')-1) : $_alias2;
				$_alias2 = (strlen($_alias2) > 3) ? substr($_alias2, 0, 2) : $_alias2;
				$_alias2 = (empty($_alias2)) ? '' : $_alias2 . '.';
			}
		}
		if(!empty($_alias2))
		{
			break;
		}
	}
	
	// Set prefix(es) to use
	$_prefix = ($_alias) ? (($_alias2) ? array($_alias, $_alias2) : array( $_alias)) : array(' ', " ", '\(', '`');

	// Run through the query
	while ($startPos < $n)
	{
		// More variables
		$_stop = true;
		$quoteChar = '';
		$_found = array();

		// Check for fields to replace
		foreach($_find as $search)
		{
			foreach ($_prefix as $pre)
			{
				$j = $startPos;
				$match = array();
				while (preg_match('/' . $pre . $search . '/i', $sql, $match, PREG_OFFSET_CAPTURE, $j))
				{
					// Kill infinite loop
					if($_found[$match[0][1]] == array($pre, $search, $match[0][1]))
					{
						break;
					}
					$_stop = false;
					$_found[$match[0][1]] = array($pre, $search, $match[0][1]);
					$j = $match[0][1]+1;
				}
			}
		}

		// If no fields are found, stop cycle
		if ($_stop === true)
		{
			break;
		}

		// Determine where to end current query chunk
		$j = strpos( $sql, "'", $startPos );
		$k = strpos( $sql, '"', $startPos );
		if (($k !== FALSE) && (($k < $j) || ($j === FALSE)))
		{
			$quoteChar	= '"';
			$j			= $k;
		}
		else
		{
			$quoteChar	= "'";
		}
		if ($j === false)
		{
			$j = $n;
		}

		// Take query chunk of the original statement and replace the fields on it
		$temp = substr( $sql, $startPos, $j - $startPos );

		foreach($_found as $_run)
		{
			// Yet more variables
			$pre = $_run[0];
			$search = $_run[1];
			$pos = $x = $_run[2];
			$match = array();
			if($pos > $j)
			{
				continue;
			}
			$_pos_as = 0;
			$_count = false;
			
			
			
			// Find the closest character that separates fields
			while( $_pos_as != $x ) 
			{
				if( $x == 1 || $sql{$x} == ',' ) 
				{
					$_pos_as = $x = $n;
					break;
				} 
				elseif(strtolower(substr($sql,$x,5)) == 'count') 
				{
					$_count = true;
					$_pos_as = $x = 0;
					break;
				} 
				elseif($sql{$x} == '=' || strtolower(substr($sql,$x,2)) == 'as' || strtolower(substr($sql,$x,2)) == 'on') 
				{
					$_pos_as = $x;
					break;
				} 
				else 
				{
					$x--;
				}
			}

			// Does field need to be renamed?
			if(!($pos < $_from && $pos > $_pos_as))
			{
				$post = ($pre == '`') ? '`' : '';
				$length = strlen($pre . $search);
				$length = ($pre == '`') ? $length++ : $length;
				$replace = (($search == 'guest' || $search == 'block') && !($_insert || $_update)) ? ' NOT ' : '';
				if(is_array($_replace[$search]))
				{
					foreach($_replace[$search] as $work)
					{
						$replace .= ($work == '`user_active` as `block`' || $work == '`session_logged_in` as `guest`') ? ' NOT ' . $pre : $pre;
						$replace .= $work . $post . ', ';
					}
					$replace = substr($replace, 0, strlen($replace)-2);
				}
				else
				{
					$replace .= $pre . $_replace[$search] . $post;
				}
				if (!($_count == true || $pos > $_from || $pos > $_pos_as || $_as_following || $_insert))
				{
					$replace .= $_add[$search];
				}
				$pos = ($pos > strlen($temp)) ? 0 : $pos;
				$search = $pre . $search . $post;
				preg_match('/' . $search . '/i', $temp, $match, PREG_OFFSET_CAPTURE, $pos);
				$loc = $match[0][1];
				$_as_following = (strpos($sql, 'as', $pos) - $pos > 0 && ((strpos($sql, 'as', $pos) - $pos) < (strlen($search) + 3))) ? true : false;
				$_as_following = ($_as_following) ? true : ((strpos($sql, 'AS', $pos) - $pos > 0 && ((strpos($sql, 'AS', $pos) - $pos) < (strlen($search) + 3))) ? true : false);
				$temp = substr_replace( $temp, $replace, $loc, $length );
				
			}
		}
	
		// Add changes to SQL for output
		$literal .= $temp;
		$startPos = $j;
		$j = $startPos + 1;

		// Stop if query completed
		if ($j >= $n)
		{
			break;
		}

		// quote comes first, find end of quote
		while (TRUE)
		{
			$k = strpos( $sql, $quoteChar, $j );
			$escaped = false;
			if ($k === false)
			{
				break;
			}
			$l = $k - 1;
			while ($l >= 0 && $sql{$l} == '\\')
			{
				$l--;
				$escaped = !$escaped;
			}
			if ($escaped)
			{
				$j	= $k+1;
				continue;
			}
			break;
		}

		// error in the query - no end quote; ignore it
		if ($k === FALSE)
		{
			break;
		}

		// Proceed
		$literal .= substr( $sql, $startPos, $k - $startPos + 1 );
		$startPos = $k+1;
	}

	// Adds remainder of query to SQL for output
	if ($startPos < $n)
	{
		$literal .= substr( $sql, $startPos, $n - $startPos );
	}

	return str_replace(array('```','``'), '`', $literal);
}

?>