<?php
/**
* @version $Id: import.php,v 2.0.0 2005/12/07 15:23:00 impleri
* @package heimdal
* @copyright (C) 2005 impleri software
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Heimdal is Free Software
*/
define( '_VALID_MOS', 1 );
define( 'PHPBB_VERSION', '.0.18' );
define( 'PLUS_VERSION', '.0.0' );
// This is the amount of rows we will get each page reload
$lim  = 5;
// This is the amount of time we should wait before refreshing the page
$time = 10;
include_once( '../globals.php' );
require_once( '../configuration.php' );
require_once( '../includes/mambo.php' );
$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
$database->debug( $mosConfig_debug );
$sql_struct = $rows = $users = array();

/*
  * Runs through SQL of $sqlfile, replacing #__ with
  * $DBPrefix
  * Taken from Joomla/Mambo install
  */
function populate_db($DBname, $DBPrefix, $sqlfile='')
{
	global $errors;
	mysql_select_db($DBname);
	$mqr = @get_magic_quotes_runtime();
	@set_magic_quotes_runtime(0);
	$sql = fread(fopen("sql/".$sqlfile, "r"), filesize("sql/".$sqlfile));
	@set_magic_quotes_runtime($mqr);
	$pieces  = split_sql($sql);
	for ($i=0; $i<count($pieces); $i++) {
		$pieces[$i] = trim($pieces[$i]);
		if(!empty($pieces[$i]) && $pieces[$i] != "#") {
			$pieces[$i] = str_replace( "#__", $DBPrefix, $pieces[$i]);
			if (!$result = mysql_query ($pieces[$i])) {
				$errors[] = array ( mysql_error(), $pieces[$i] );
			}
		}
	}
	return;
}

function split_sql($sql)
{
	$sql = trim($sql);
	$sql = ereg_replace("\n#[^\n]*\n", "\n", $sql);
	$buffer = array();
	$ret = array();
	$in_string = false;
	for($i=0; $i<strlen($sql)-1; $i++) {
		if($sql[$i] == ";" && !$in_string) {
			$ret[] = substr($sql, 0, $i);
			$sql = substr($sql, $i + 1);
			$i = 0;
		}
		if($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
			$in_string = false;
		}
		elseif(!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
			$in_string = $sql[$i];
		}
		if(isset($buffer[1])) {
			$buffer[0] = $buffer[1];
		}
		$buffer[1] = $sql[$i];
	}
	if(!empty($sql)) {
		$ret[] = $sql;
	}
	return($ret);
}

function gzip_PrintFourChars($Val)
{
	for ($i = 0; $i < 4; $i ++) {
		$return .= chr($Val % 256);
		$Val = floor($Val / 256);
	}
	return $return;
}

/*
  * Imports array of objects ($rows) into users table
  * Also adapts DB from phpBB component  if $com is true
  */
function import_users($rows, $set, $com=false)
{
	global $database, $page, $lim;

	// Set numbers for first round
	$uidno = ($page*$lim) + 1;
	$tables_pbb = array(
		'%__user_group' => array('user_id'), 
		'%__topics' => array('topic_poster'), 
		'%__posts' => array('poster_id'), 
		'%__privmsgs' => array('privmsgs_from_userid', 'privmsgs_to_userid'), 
		'%__banlist' => array('ban_id'), 
		'%__vote_voters' => array('vote_user_id'),
		'%__topics_watch' => array('user_id'),
	);
	$tables_jos = array(
		'#__content' => array('created_by', 'modified_by'),
		'#__messages' => array('user_id_to', 'user_id_from'), 
	);
	$tables = ($set == 'jos') ? $tables_jos : $tables_pbb;
	$tables = ($com) ? array_merge($tables_jos, $tables_pbb) : $tables;
	
	foreach($rows as $row) 
	{
		// Increment user_id
		$uidno++;
				
		// Work with fields so we can use $database
		$old_id = $row->user_id;
		$row->password = $row->user_password;
		$row->email = $row->user_email;
		$row->block = ($row->user_active) ? 0 : 1;
		$row->activation = $row->user_actkey;
		unset($row->user_id, $row->user_password, $row->user_email, $row->user_active, $row->user_actkey);
		
		// Sync phpBB and Joomla/Mambo info
		switch ($set)
		{
			case 'pbb':
				$row->registerDate = date("Y-m-d H:i:s", $row->user_regdate);
				$row->lastvisitDate = date("Y-m-d H:i:s", $row->user_lastvisit);
				$row->usertype = ($row->user_level == 1) ? 'administrator' : '';
				$row->gid = ($row->user_level == 1) ? 24 : 18;
				$row->name = $row->username;
				break;
			case 'jos':
				if(!$com)
				{
					$row->user_regdate = strtotime($row->registerDate);
					$row->user_lastvisit = strtotime($row->lastvisitDate);
					$row->user_level = ($row->gid > 23) ? 1 : 0;
				}
				break;
		}
		$row->id = $uidno;
		$gid = $row->gid;
		$name = $row->name;

		// Who we have
		echo $name;
		if (!$database->insertObject('#__users', $row))
		{
			echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
		}
		echo ".";
		
		// Gather what we need to sync later
		$args = array();
		while(list($table, $fields) = @each($tables))
		{
			if(is_array($fields))
			{
				foreach($fields as $field)
				{
					$arg = array();
					$arg['table'] = $table;
					$arg['field'] = $field;
					$sql = "SELECT * FROM `$table`
						WHERE `$field` = $old_id";
					$database->setQuery($sql);
					if($rows = $database->loadObjectList())
					{
						$sql = "SHOW INDEX FROM `$table`";
						$database->setQuery($sql);
						$keys = $database->loadObjectList();
						foreach($keys as $temp)
						{
							if($temp->Key_name == "PRIMARY")
							{
								$arg['key'] = $key = $temp->Column_name;
							}
						}
						if(!$key)
						{
							$key = ($arg['table'] == '%__user_group') ? 'group_id' : '';
							$key = ($arg['table'] == '%__vote_voters') ? 'vote_id' : '';
							$key = ($arg['table'] == '%__topics_watch') ? 'topic_id' : '';
						}
						$value = array();
						foreach($rows as $row)
						{
							$value[] = $row->$key;
						}
						$arg['value'] = $value;
						$args[] = $arg;
					}
				}
			}
		}
		if(!empty($args))
		{
			$argument = serialize($args);
			$sql = "INSERT INTO `#__user_fields` (`new_id`, `old_id`, `name`, `argument`)
				VALUES ( $uidno, $old_id, '$name', '$argument')";
			$database->setQuery($sql);
			if (!$database->query())
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
		}
	}
	
	return;
}

/*
  * Gathers from temp table everything needing syncing and syncs it
  */
function sync_users()
{
	global $database, $page, $lim;
	//Get info from table
	$loc = $page * $lim;
	$sql = "SELECT * FROM `#__user_fields`
		LIMIT $loc, $lim";
	$database->setQuery($sql);
	$rows = $database->loadObjectList();
	
	foreach($rows as $row)
	{
		$old_id = $row->old_id;
		$name = $row->name;
		$new_id = $row->new_id;
		$args = unserialize($row->argument);
		
		echo "<br />Syncing $name ...";
		// Fix user id's
		foreach($args as $arg)
		{
			$table = $arg['table'];
			$field = $arg['field'];
			$key = $arg['key'];
			$value = (is_array($arg['value'])) ? implode(",", $arg['value']) : $arg['value'];
			$sql = "UPDATE `$table` SET `$field` = $new_id WHERE `$field` = $old_id AND `$key` IN ($value)";
			$database->setQuery($sql);
			if(!$database->query())
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
			echo ".";
		}
		echo ".done!";
	}
	return;
}

/*
  * Runs through array of SQL commands and
  * Processes each one separately
  * If $use is false, uses mysql_query instead of $database
  */
function run_array($sql_array, $use=true)
{
	global $database;
	if($use)
	{
		foreach ( $sql_array as $sql ) 
		{
			$database->setQuery($sql);
			if (!$database->query()) 
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
			echo ".";
		}
	}
	else
	{
		foreach ( $sql_array as $sql ) 
		{
			mysql_query( $sql );
			if (mysql_errno()) 
			{
				echo "<br /><font color=\"red\">" . mysql_error() . "</font>";
			}
			echo ".";
		}
	}
	echo ".done";
	return;
}

/*
  * Compares columns and keys of $table1 with $table2 and
  * Adds to $table1 what it lacks from $table2
  * Of course, this means that the primary keys must be the same
  */
function sync_table($table1, $table2, $name)
{
	global $database;
	echo "<br /> Adding additional fields to $name table...";
	$musers = NULL;
	$used_fields = array();
	$sql = "DESCRIBE `$table1`";
	$database->setQuery($sql);
	$musers = $database->loadAssocList();
	foreach ($musers as $field) 
	{
		$used_fields[] = $field['Field'];
	}
	$pusers = NULL;
	$sql = "DESCRIBE `$table2`";
	$database->setQuery($sql);
	$pusers = $database->loadAssocList();
	foreach($pusers as $field) 
	{
		if(!in_array($field['Field'],$used_fields)) 
		{
			$sql = "ALTER TABLE `$table1` ADD COLUMN `".$field['Field']."` ".$field['Type']." ";
			if($field['Default'] != '') 
			{
				$sql .= "DEFAULT '" . $field['Default'] . "' ";
			}
			if($field['Null'] != 'YES') 
			{
				$sql .= "NOT NULL";
			}
			$database->setQuery($sql);
			if (!$database->query()) 
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
			echo ".";
		}
	}
	echo ".";
	$sql = "SHOW INDEX FROM `$table1`";
	$database->setQuery($sql);
	$musers = $database->loadAssocList();
	foreach ($musers as $field) 
	{
		$used_fields[] = $field['Key_name'];
	}
	$pusers = $do_field = NULL;
	$sql = "SHOW INDEX FROM `$table2`";
	$database->setQuery($sql);
	$pusers = $database->loadAssocList();
	foreach($pusers as $field) 
	{
		if(!in_array($field['Key_name'],$used_fields)) 
		{
			$do_field['Key_name']['Key_name'] = $field['Key_name'];
			$do_field['Key_name']['Column_name'][] = $field['Column_name'];
		}
	}
	if(!empty($do_field))
	{
		foreach($do_field as $field) 
		{
			if(is_array($field['Column_name'])) 
			{
				$do_columns = '`' . implode("`, `", $field['Column_name']) . '`';
			}
			else
			{
				$do_columns = '`' . $field['Column_name'] . '`';
			}
			$sql = "ALTER TABLE `$table1` ADD INDEX `".$field['Key_name']."` (".$do_columns.")";
			$database->setQuery($sql);
			if (!$database->query()) 
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
			echo ".";
		}
	}
	echo ".done!";
	return;
}

/*
  * Checks database for tables starting with $prefix and 'old_' . $prefix
  * Drops tables with $prefix and renames tables with 'old_' . $prefix
  * to the first
  */
function restore_tables ($prefix, $name)
{
	global $database;
	echo "<br /> Restoring $name tables";
	$oldtables = array();
	$newtables = array();
	$tables = array();
	$database->setQuery( "SHOW TABLES" );
	if ($tables = $database->loadResultArray()) 
	{
		// Grabs current tables and backed up tables
		foreach ($tables as $table) 
		{
			if(strpos($table, $prefix) === 0) 
			{
				$oldtables[] = $table;
			}
			if(strpos($table, 'old_' . $prefix) === 0) 
			{
				$newtables[] = $table;
			}
			echo ".";
		}
		
		// Remove current tables
		foreach($oldtables as $table) 
		{
			$sql = "DROP TABLE `$table`";
			$database->setQuery( $sql );
			if (!$database->query())
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
			echo ".";
		}
		
		// Restore backed up tables
		foreach($newtables as $table) 
		{
			$newtable = str_replace('old_' . $prefix, $prefix, $table);
			$sql = "RENAME TABLE `$table` TO `$newtable`";
			$database->setQuery( $sql );
			if (!$database->query()) 
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
			echo ".";
		}
		
		echo ".done!";
	} 
	else 
	{
		// Database has no tables
		echo "<br />There was an error reading the database<br />";
	}
	return;
}

/*
  * Gathers schema info for $table and
  * Returns a CREATE TABLE statement for $new_table
  * If $drop is true, will also add a DROP TABLE statement first
  * Uses $crlf as the line feed (default is unix style)
  * Adapted from phpBB's DB utility
  */
function get_table_def ($table, $new_table='', $drop=0, $crlf="\n")
{
	global $database;
	if (empty($new_table))
	{
		$new_table = $table;
	}

	$schema_create = "";
	$field_query = "SHOW FIELDS FROM `$table`";
	$key_query = "SHOW KEYS FROM `$table`";

	//
	// If the user has selected to drop existing tables when doing a restore.
	// Then we add the statement to drop the tables....
	//
	if ($drop == 1)
	{
		$schema_create .= "DROP TABLE IF EXISTS $table;$crlf";
	}

	$schema_create .= "CREATE TABLE $new_table($crlf";

	//
	// Ok lets grab the fields...
	//
	$database->setQuery($field_query);
	if(!($rows = $database->loadAssocList()))
	{
		echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
		return "TRUNCATE #__session";
	}
	foreach ($rows as $row)
	{
		$schema_create .= '	' . $row['Field'] . ' ' . $row['Type'];
		if(!empty($row['Default']))
		{
			$schema_create .= ' DEFAULT \'' . $row['Default'] . '\'';
		}
		if($row['Null'] != "YES")
		{
			$schema_create .= ' NOT NULL';
		}
		if($row['Extra'] != "")
		{
			$schema_create .= ' ' . $row['Extra'];
		}
		$schema_create .= ",$crlf";
	}

	//
	// Drop the last ',$crlf' off ;)
	//
	$schema_create = ereg_replace(',' . $crlf . '$', "", $schema_create);

	//
	// Get any Indexed fields from the database...
	//
	$database->setQuery($key_query);
	if(!($rows = $database->loadAssocList()))
	{
		echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
	}
	foreach ($rows as $row)
	{
		$kname = $row['Key_name'];
		if(($kname != 'PRIMARY') && ($row['Non_unique'] == 0))
		{
			$kname = "UNIQUE|$kname";
		}
		if(!is_array($index[$kname]))
		{
			$index[$kname] = array();
		}
		$index[$kname][] = $row['Column_name'];
	}
	while(list($x, $columns) = @each($index))
	{
		$schema_create .= ", $crlf";
		if($x == 'PRIMARY')
		{
			$schema_create .= '	PRIMARY KEY (' . implode($columns, ', ') . ')';
		}
		elseif (substr($x,0,6) == 'UNIQUE')
		{
			$schema_create .= '	UNIQUE ' . substr($x,7) . ' (' . implode($columns, ', ') . ')';
		}
		else
		{
			$schema_create .= "	KEY $x (" . implode($columns, ', ') . ')';
		}
	}
	$schema_create .= "$crlf);";

	if(get_magic_quotes_runtime())
	{
		return(stripslashes($schema_create));
	}
	else
	{
		return($schema_create);
	}

}

/*
  * Grabs all table names in the database
  * Optimizes those tables
  */
function optimize_db ()
{
	global $database;
	$database->setQuery( "SHOW TABLES FROM `$mosConfig_db`" );
	if ($tables = $database->loadResultArray()) 
	{
		$table_names = "`" . implode("`, `", $tables) . "`";
		$sql = "OPTIMIZE TABLE $table_names";
	}
	return;
}

/*
  * Counts number of users for $set
  */
function count_users ($set)
{
	global $database;
	switch ($set)
	{
		case 'jos':
			$sql = "SELECT COUNT(`user_id`) FROM `#__user_old` 
				WHERE `user_id` > 0";
			$database->setQuery($sql);
			return $database->loadResult();
			break;
		case 'pbb':
			$sql = "SELECT COUNT(`user_id`) FROM `%__users` 
				WHERE `user_id` > 0";
			$database->setQuery($sql);
			return $database->loadResult();
			break;
		case 'sync':
			$sql = "SELECT COUNT(`new_id`) FROM `#__user_fields`";
			$database->setQuery($sql);
			return $database->loadResult();
			break;
		default:
			return false;
			break;
	}
	return false;
}

/*
  * Checks location of data import
  * Returns 0 if not finished
  */
function check_status ($check)
{
	global $page, $lim;
	switch ($check)
	{
		case 'jos':
		case 'jos_com':
			$num = count_users('jos');
			$pages = $num/$lim;
			if($page >= $pages)
			{
				return 1;
			}
			else
			{
				return 0;
			}
			break;
		case 'jos_pbb':
			$num = count_users('pbb');
			$pages = $num/$lim;
			if($page >= $pages)
			{
				$num2 = $count_users('jos');
				$pages2 = $num2/$lim;
				$pages2 += $pages;
				if($page >= $pages2)
				{
					return 2;
				}
				else
				{
					return 1;
				}
			}
			else
			{
				return 0;
			}
			break;
		case 'pbb':
			$num = count_users('pbb');
			$pages = $num/$lim;
			if($page >= $pages)
			{
				return 1;
			}
			else
			{
				return 0;
			}
			break;
		case 'sync':
			$num = count_users('sync');
			$pages = $num/$lim;
			if($page >= $pages)
			{
				return 1;
			}
			else
			{
				return 0;
			}
			break;
		default:
			return 2;
			break;
	}
	return 0;
}

// Let's get the form variables
$db_backup = ($HTTP_POST_VARS['backup']) ? true : false;
$go = ($HTTP_POST_VARS['go']) ? true : false;
$type = $HTTP_POST_VARS['type'];
$type = ($type) ? $type : $HTTP_GET_VARS['type'];
$step = $HTTP_POST_VARS['step'];
$step = ($step) ? $step : $HTTP_GET_VARS['step'];
$page = ($HTTP_GET_VARS['page']) ? intval($HTTP_GET_VARS['page']) : 0;
$page_new = $page + 1;
$import_done = ($HTTP_GET_VARS['import_done']) ? true : false;
$import_start = ($step == 'two') ? true : false;
$sync_done = ($HTTP_GET_VARS['sync_done']) ? true : false;
$sync_start = ($step == 'three') ? true : false;
if($import_start)
{
	switch ($type)
	{
		case 'mp20':
		case 'oldmp':
			$import_done = true;
			break;
		case 'jos':
		case 'jos_com':
		case 'pbb':
			$import_done = (check_status($type) >= 1) ? true : false;
			break;
		case 'jos_pbb':
			$import_done = (check_status($type) >= 2) ? true : false;
			break;
		default:
			$import_done = true;
			break;
	}
	$page = ($import_done) ? 0 : $page;
}
if($sync_start)
{
	$sync_done = (check_status('sync') >= 1) ? true : false;
	$page = ($sync_done) ? 0 : $page;
}

if($db_backup)
{
	$create = array();
	if(extension_loaded("zlib")) {
		@ob_start();
		header("Content-Type: application/x-gzip");
		header("Content-disposition: attachment; filename=\"db_backup.sql.gz\"");
		header("Pragma: no-cache");
	}
	else {
		header("Content-Type: text/x-sql");
		header("Content-disposition: attachment; filename=\"db_backup.sql\"");
		header("Pragma: no-cache");
	}
	echo "#\n";
	echo "# phpBB Backup Script\n";
	echo "# Dump of tables for " . $mosConfig_db . "\n";
	echo "#\n# DATE : " .  gmdate("d-m-Y H:i:s", time()) . " GMT\n";
	echo "#\n";
	$create = $database->getTableCreate($database->getTableList());
	while (list($table, $val) = each($create)) {
		echo "#\n# TABLE: " . $table . "\n#\n";
		echo $val[0] . "; \n";
		echo "\n#\n# Table Data for $table\n#\n\n";
		$database->setQuery("SELECT * FROM `$table`");
		$rows = $database->loadAssocList();
		foreach ($rows as $row) {
			$tbl_keys = array();
			$tbl_vals = array();
			while (list($tbl_key, $tbl_val) = each($row)) {
				$tbl_keys[] = "`$tbl_key`";
				$tbl_vals[] = addslashes($tbl_val);
			}
				$keys = implode(', ', $tbl_keys);
				$vals = "'" . implode('\', \'', $tbl_vals) . "'";
				echo "INSERT INTO `$table` ( $keys ) VALUES ( '$vals' ) \n";
		}
	}
	if(extension_loaded("zlib")) {
		$Size = ob_get_length();
		$Crc = crc32(ob_get_contents());
		$contents = gzcompress(ob_get_contents());
		ob_end_clean();
		echo "\x1f\x8b\x08\x00\x00\x00\x00\x00".substr($contents, 0, strlen($contents) - 4).gzip_PrintFourChars($Crc).gzip_PrintFourChars($Size);
	}
	else {
		ob_end_flush();
	}
	exit;
}

// Let's make a page...
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Heimdal 1.0.x - Import Utility</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<? if($import_start & !$import_done)
{
?>
<meta http-equiv="refresh" content="<?php echo $time; ?>,import.php?step=<?php echo $step; ?>&amp;type=<?php echo $type; ?>&amp;page=<?php echo $page_new; ?>&amp;import_done=<?php echo $import_done; ?>" />
<?php
}
?>
<? if($sync_start & !$sync_done)
{
?>
<meta http-equiv="refresh" content="<?php echo $time; ?>,import.php?step=<?php echo $step; ?>&amp;page=<?php echo $page_new; ?>&amp;sync_done=<?php echo $sync_done; ?>" />
<?php
}
?>
<link rel="shortcut icon" href="../images/favicon.ico" />
<link rel="stylesheet" href="install.css" type="text/css" />
<style type="text/css">
<!--
.style2 {
	color: #CCCCCC;
	font-size: 24px;
	font-family: Georgia, "Times New Roman", Times, serif;
}
.gen {font-size: 12px}
-->
</style>
</head>
<body>
<div id="wrapper">
    <div id="header">
		<div id="mambo"><table width="100%"  border="0" cellspacing="0" cellpadding="0"><tr><td><img src="header_install.png" alt="Mambo Installation" /></td><td align="right" valign="bottom">Version 2.1</td>
		</tr></table></div>
    </div>
</div>
<div id="ctr" align="center">
    <form method="post" name="form" action="./import.php">
    <div class="install">
		<div id="stepbar">
<?php
if(!isset($step)) 
{
?>
			<div class="step-on">Start</div>
			<div class="step-off">Structure</div>
			<div class="step-off">Data</div>
			<div class="step-off">Config</div>
			<div class="step-off">Finish</div>
<?php
}
elseif($step == "one") 
{ 
?>
			<div class="step-off">Start</div>
			<div class="step-on">Structure</div>
			<div class="step-off">Data</div>
			<div class="step-off">Config</div>
			<div class="step-off">Finish</div>
<?php
}
elseif($step == "two") 
{ 
?>
			<div class="step-off">Start</div>
			<div class="step-off">Structure</div>
			<div class="step-on">Data</div>
			<div class="step-off">Config</div>
			<div class="step-off">Finish</div>
<?php
}
elseif($step == "three") 
{ 
?>
			<div class="step-off">Start</div>
			<div class="step-off">Structure</div>
			<div class="step-off">Data</div>
			<div class="step-on">Config</div>
			<div class="step-off">Finish</div>
<?php
}
elseif($step == "four") 
{ 
?>
			<div class="step-off">Start</div>
			<div class="step-off">Structure</div>
			<div class="step-off">Data</div>
			<div class="step-off">Config</div>
			<div class="step-on">Finish</div>
<?php
}
else
{ 
?>
			<div class="step-off">Start</div>
			<div class="step-off">Structure</div>
			<div class="step-off">Data</div>
			<div class="step-off">Config</div>
			<div class="step-off">Finish</div>
<?php
}
?>
		</div>
		<div id="right">
			<div id="step">Import Utility</div>
			<div class="clr"></div>
<?php
if(!isset($step)) 
{
?>
			<input type="hidden" name="step" value="one" />
			<h1>Backup &amp; Select</h1>
			<div class="licensetext">This tool is designed to update the database to Heimdal 1.0.0, as well as re-sync your original data (users, content, forums, posts, messages, etc).
			<br /></div>
			<div class="clr"></div>
			<div class="ctr"><br />
				<b>Download a backup of your database before proceeding</b>:<br />
				<input type="submit" name="backup" value="Download" />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
				<b>Choose your previous installation</b>:<br />
				(Previous version number does not matter here)<br />
				<select name="type">
				  <option value="mp" selected="selected">Heimdal, Mambo Plus, or MOSphpBB</option>
				  <option value="pbb">phpBB2</option>
				  <option value="jos">Joomla/Mambo</option>
				  <option value="jos_pbb">Both Joomla/Mambo and phpBB2</option>
				  <option value="jos_com">Joomla/Mambo with phpBB component</option>
				</select>
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />Then:<br />
				<input type="submit" name="go" value="Start" />
			</div>
<?php
}
elseif($step == "one") 
{ 
?>
			<input type="hidden" name="step" value="two" />
			<h1>Structure</h1>
			<div class="licensetext"><b>Do not reload this page...syncing database structure...</b>
			<br /></div>
			<div class="clr"></div>
			<div class="ctr"><br />
	<?php
	switch ($type)
	{
		case 'mp':
			$sql = "SELECT `config_value` FROM `%__config` WHERE `config_name` = 'version'";
			$database->setQuery( $sql );
			if (!($version = $database->loadResult()))
			{
				echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
			}
			$version = str_replace('.0.', '', $version);
			$type = (intval($version) >= 12) ? 'mp20' : 'oldmp';
			break;
		case 'jos':
		case 'jos_com':
		case 'jos_pbb':
		case 'pbb':
			break;
		default:
			$type = 'jos';
			break;
	}
	
	$sql_struct = array();
	switch ($type)
	{
		case 'oldmp':
			// Change table names
			echo "<br /> Initial table alterations...";
			$sql_struct[] = 'RENAME TABLE `users` TO `#__users`';
			$sql_struct[] = 'DROP TABLE IF EXISTS `sessions`';
			run_array($sql_struct);
			
			break;
		case 'mp20':
			break;
		case 'pbb':
			// Restore phpBB tables
			restore_tables ($mosConfig_bbprefix, 'phpBB');
	
			// Add additional fields to users table
			sync_table('#__users', '%__users', 'users');
			
			break;
		case 'both':
			// Change users table
			echo "<br /> Initial table alterations...";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `id` `user_id` mediumint(8) NOT NULL default '0'";
			$sql_struct[] = "UPDATE `".$mosConfig_dbprefix."users` SET block = NOT block";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `block` `user_active` tinyint(1) default '0'";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `password` `user_password` varchar(32) NOT NULL default ''";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `email` `user_email` varchar(32) NOT NULL default ''";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `activation` `user_actkey` varchar(32) NOT NULL default ''";
			run_array($sql_struct, false);
			
			// Add additional fields to users table
			sync_table('#__users', '%__users', 'users');
			
			break;
		case 'jos_com':
			// Change users table
			echo "<br /> Initial table alterations...";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` DROP `user_active`";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `id` `user_id` mediumint(8) NOT NULL default '0'";
			$sql_struct[] = "UPDATE `".$mosConfig_dbprefix."users` SET block = NOT block";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `block` `user_active` tinyint(1) default '0'";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `password` `user_password` varchar(32) NOT NULL default ''";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `email` `user_email` varchar(32) NOT NULL default ''";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` ADD `params` TEXT NOT NULL";
			run_array($sql_struct, false);
			
			break;
		case 'jos':
		default:
			// Change users table
			echo "<br /> Initial table alterations...";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `id` `user_id` mediumint(8) NOT NULL default '0'";
			$sql_struct[] = "UPDATE `".$mosConfig_dbprefix."users` SET block = NOT block";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `block` `user_active` tinyint(1) default '0'";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `password` `user_password` varchar(32) NOT NULL default ''";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `email` `user_email` varchar(32) NOT NULL default ''";
			$sql_struct[] = "ALTER TABLE `".$mosConfig_dbprefix."users` CHANGE `activation` `user_actkey` varchar(32) NOT NULL default ''";
			run_array($sql_struct, false);
			
			// Populate phpBB database
			echo "<br /> Creating phpBB tables...";
			populate_db($mosConfig_db,$mosConfig_bbprefix,'phpbb.sql');
			echo ".done!";
			
			// Adjust phpBB config
			echo "<br /> Update phpBB config...";
			$now = time();
			$sql_struct = array();
			$sql_struct[] = "REPLACE INTO `%__config` VALUES ('board_startdate', '$now')";
			$sql_struct[] = "REPLACE INTO `%__config` VALUES ('default_lang', 'english')";
			$sql_struct[] = "UPDATE `%__topics` SET `topic_time`='$now' WHERE `topic_id`='1'";
			$sql_struct[] = "UPDATE `%__posts` SET `post_time`='$now' WHERE `post_id`='1'";
			run_array($sql_struct);
			
			// Add additional fields to users table
			sync_table('#__users', '%__users', 'users');
			
			break;
	}

	// Alter tables
	echo "<br /> Altering tables...";
	
	// Make sure mod_topics is installed
	$sql = "SELECT `id` FROM `#__modules` WHERE `module` = 'mod_topics' LIMIT 1";
	$database->setQuery( $sql );
	if (!$database->loadResult()) 
	{
		$mod->title = 'Recent Topics';
		$mod->ordering = 99;
		$mod->position = 'right';
		$mod->module = 'mod_topics';
		$mod->showtitle = 1;
		$mod->params = '';
		if (!$database->insertObject( "#__modules", $mod, "id")) 
		{
			echo "<br /><font color=\"red\">" . stripslashes($database->getErrorMsg()) . "</font>";
		}
	}
	
	// Update for phpBB 2.0.18+
	$sql_struct = array();
	if($type <> 'mp20' && $type <> 'oldmp')
	{
		$sql_struct[] = 'DROP TABLE IF EXISTS `#__user_old`';
		$sql_struct[] = 'RENAME TABLE `#__users` TO `#__user_old`';
	}
	$sql_struct[] = 'DROP TABLE IF EXISTS `#__session`';
	$sql_struct[] = "CREATE TABLE `#__session` (
		`session_id` char(32) NOT NULL default '',
		`session_user_id` mediumint(8) NOT NULL default '0',
		`username` varchar(50) default '',
		`usertype` varchar(50) default '',
		`gid` tinyint(3) unsigned NOT NULL default '0',
		`session_start` int(11) NOT NULL default '0',
		`session_time` int(11) NOT NULL default '0',
		`session_ip` char(8) NOT NULL default '0',
		`session_page` int(11) NOT NULL default '0',
		`session_logged_in` tinyint(1) NOT NULL default '0',
		`session_admin` tinyint(2) NOT NULL default '0',
		PRIMARY KEY  (`session_id`),
		KEY `session_user_id` (`session_user_id`),
		KEY `session_id_ip_user_id` (`session_id`,`session_ip`,`session_user_id`),
		KEY `whosonline` (`session_logged_in`,`usertype`)
	) TYPE=MyISAM";
	$sql_struct[] = "CREATE TABLE IF NOT EXISTS `%__sessions_keys` (
		`key_id` varchar(32) DEFAULT '0' NOT NULL,
		`user_id` mediumint(8) DEFAULT '0' NOT NULL,
		`last_ip` varchar(8) DEFAULT '0' NOT NULL,
		`last_login` int(11) DEFAULT '0' NOT NULL,
		PRIMARY KEY (`key_id`, `user_id`),
		KEY last_login (`last_login`)
		) TYPE=MyISAM";
	if($type <> 'mp20' && $type <> 'oldmp')
	{
		$sql_struct[] = "DROP TABLE IF EXISTS `#__user_fields`";
		$sql_struct[] = "CREATE TABLE IF NOT EXISTS `#__user_fields` (
			`new_id` mediumint(8) DEFAULT '0' NOT NULL,
			`old_id` mediumint(8) default '0',
			`name` varchar(25) DEFAULT '',
			`argument` text,
			PRIMARY KEY (`new_id`)
		) TYPE=MyISAM";
	}
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('allow_autologin','1')";
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('max_autologin_time','0')";
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('script_path', '/forums/')";
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('server_port', '80')";
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('server_name', '".$site_url."')";
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('cookie_name', '".$mosConfig_cookie."')";
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('version', '" . PHPBB_VERSION . "')";
	$sql_struct[] = "REPLACE INTO `%__config` (`config_name`, `config_value`) VALUES ('plus_version', '" . PLUS_VERSION . "')";
	$sql_struct[] = 'TRUNCATE `#__core_acl_aro`';
	$sql_struct[] = 'TRUNCATE `#__core_acl_groups_aro_map`';
	run_array($sql_struct);
	
	// Duplicate #__users table and wipe #__users clean
	if($type <> 'mp20' && $type <> 'oldmp')
	{
		run_array(array( get_table_def("#__user_old", "#__users")));
		run_array(array("INSERT INTO `#__users` (`user_id`, `user_active`, `username`, `name`, `user_level`, `gid`, `user_posts`, `user_allowhtml`, `user_allowbbcode`, `user_allowsmile`, `user_rank` ) VALUES (-1, 0, 'Anonymous', 'Anonymous', 0, 0, 0, 1, 1, 1, 0)"));
	}
?>
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
				<input type="hidden" name="type" value="<?php echo $type; ?>" />
				<input type="submit" name="submit" value="Continue" />
			</div>
<?php
}
elseif($step == "two") 
{
?>
			<input type="hidden" name="step" value="three" />
			<h1>Data</h1>
			<div class="licensetext"><b>Do not reload this page...syncing data...<br />
				This page will reload automatically until finished</b><br />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
	<?php
	$loc = $page * $lim;
	switch ($type)
	{
		case 'mp20':
		case 'oldmp':
			break;
		case 'jos':
		case 'jos_com':
			echo "<br />Importing Joomla data...";
			$com = ($type == 'jos_com') ? true : false;
			$sql = "SELECT * FROM `#__user_old` 
				WHERE `user_id` > 0 
				ORDER BY `user_id` ASC
				LIMIT $loc, $lim";
			$database->setQuery( $sql);
			if (!($rows = $database->loadObjectList()))
			{
				echo "<br />Error in obtaining users information:<br />" . $database->getErrorMsg();
				exit;
			}
			echo ".";
			import_users($rows, 'jos', $com);
				break;
		case 'jos_pbb':
			if(check_status($type) < 1)
			{
				$form = 'phpBB';
				$table_use = "%__users";
				$style = 'pbb';
			}
			elseif(check_status($type) > 0)
			{
				$form = 'Joomla';
				$table_use = "#__user_old";
				$style = 'jos';
				$num = $count_users('pbb');
				$pages = $num/$lim;
				$loc = ($pages-$page) * $lim;
			}
				echo "<br />Importing $form data...";
				$sql = "SELECT * FROM `$table_use` 
					WHERE `user_id` > 0 
					ORDER BY `user_id` ASC
					LIMIT $loc, $lim";
				$database->setQuery( $sql);
				if (!($rows = $database->loadObjectList()))
				{
					echo "<br />Error in obtaining users information:<br />" . $database->getErrorMsg();
					exit;
				}
				echo ".";
				import_users($rows, $style);
				break;
		case 'pbb':
			echo "<br />Importing phpBB data...";
			$sql = "SELECT * FROM `%__users` 
				WHERE `user_id` > 0 
				ORDER BY `user_id` ASC
				LIMIT $loc, $lim";
			$database->setQuery( $sql);
			if (!($rows = $database->loadObjectList()))
			{
				echo "<br />Error in obtaining users information:<br />" . $database->getErrorMsg();
				exit;
			}
			echo ".";
			import_users($rows, 'pbb');
			break;
		default:
			break;
	}

	// UPDATE ACL
	if($import_done)
	{
		echo "<br />Updating Joomla ACL (part 1)...";
		$sql_struct = array();
		$sql_struct[] = "INSERT INTO `#__core_acl_aro` SET `aro_id`=9";
		$sql_struct[] = "INSERT INTO `#__core_acl_aro` (`value`, `name`) SELECT `user_id`, `name` FROM `#__users` WHERE `user_id` > 0";
		$sql_struct[] = "DELETE FROM `#__core_acl_aro` WHERE `aro_id` < 10 OR `value` < 1";
		run_array($sql_struct);
		echo "<br />Updating Joomla ACL (part 2)...";
		$sql_struct = array();
		$sql_struct[] = "UPDATE `#__core_acl_aro` SET `section_value` = 'users'";
		$sql_struct[] = "INSERT INTO `#__core_acl_groups_aro_map` (`group_id`, `aro_id`) SELECT u.`gid`, a.`aro_id` FROM `#__users` u, `#__core_acl_aro` a WHERE a.`value` = u.`user_id`";
		run_array($sql_struct);
	}
	?>
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
	<?php if($import_done)
	{
	?>
				<input type="submit" name="submit" value="Continue" />
	<?php
	}
	?>
			</div>
<?php
}
elseif($step == "three") 
{ 
?>
			<input type="hidden" name="step" value="four" />
			<h1>Sync</h1>
			<div class="licensetext"><b>Do not reload this page...syncing users...<br />
				This page will reload automatically until finished</b><br />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
	<?php
	// Sync all data
	echo "<br /> Syncing users data...";
	sync_users();
	echo "<br /> ...done!";
	?>
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
	<?php if($sync_done)
	{
	?>
				<input type="submit" name="submit" value="Finish" />
	<?php
	}
	?>
			</div>
<?php
}
elseif($step == "four") 
{
	optimize_db();
?>
			<h1>Success</h1>
			<div class="ctr"><br />
	<?php
	// Write out the phpBB config file.
	@include("../forums/config.php");

	if( !defined("PHPBB_INSTALLED") )
	{
		echo "<br /> Writing phpBB config file...";
		$config = "<?php\n\n";
		$config .= "\n// phpBB 2.x auto-generated config file\n// Do not change anything in this file!\n\n";
		$config .= "\$dbms = 'mysql4';\n\n";
		$config .= "\$dbhost = '$mosConfig_host';\n";
		$config .= "\$dbname = '$mosConfig_db';\n";
		$config .= "\$dbuser = '$mosConfig_user';\n";
		$config .= "\$dbpasswd = '$mosConfig_password';\n";
		$config .= "\$table_prefix = '$mosConfig_bbprefix';\n";
		$config .= "\$mos_prefix = '$mosConfig_dbprefix';\n";
		$config .= "define('PHPBB_INSTALLED', true);\n\n";	
		$config .= "?" .">"; // Done this to prevent highlighting editors getting confused!
		
		if (file_exists( '../forums/config.php' )) 
		{
			$canWrite = is_writable( '../forums/config.php' );
		} 
		else 
		{
			$canWrite = is_writable( '../forums' );
		}
	
		if ($canWrite && ($fp = fopen("../forums/config.php", "w"))) 
		{
			fputs( $fp, $config, strlen( $config ) );
			fclose( $fp );
		}
		else 
		{
			$canWrite = false;
		}
		echo ".done!";
	}
	else 
	{
		$canWrite = true;
	}
	if(!$canWrite)
	{
	?>
				<table>
					<tr>
						<td class="small">
							Your phpBB config file or directory is not writeable,
							or there was a problem creating the configuration file. You'll have to
							upload the following code by hand. Click in the textarea to highlight
							all of the code.
						</td>
					</tr>
					<tr>
						<td align="center">
							<textarea rows="5" cols="60" name="configcode" onclick="javascript:this.form.configcode.focus();this.form.configcode.select();" ><?php echo htmlspecialchars( $config );?></textarea>
						</td>
					</tr>
				</table>
	<?php
	}
	?>
				<b>Now, delete  the /installation/ directory.</b><br />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
				<b>Check your data to make sure everything syncronised correctly.</b><br />
			</div>
<?php
}
else 
{
?>
			<h1>Error</h1>
			<div class="ctr"><br />
				<b>An error has occured.</b><br />
			</div>
			<div class="clr"></div>
			<div class="ctr"><br />
				Erase your database, re-install the database (thanks to what you just downloaded), then start over.<br />You may also scream in agony during this process.
			</div>
<?php
}
?>
			<div class="clr"></div>
		</div>
		<div id="break"></div>
		<div class="clr"></div>
		<div class="clr"></div>
	</div>
	</form>
</div>
<div class="ctr">This site powered by <a href="http://demo.impleri.net/">Heimdal</a> 1.0<br />
	<a href="http://www.joomla.org" target="_blank">Joomla</a> is Free Software released under the GNU/GPL License.
</div>
</body>
</html>
